#include <cDefBF561.h>
#include <sysreg.h>
#include <ccblkfn.h>
#include <sys/exception.h>

void loader_commands(void);
extern int SECOND_STAGE_LOADER(int, int);

void Init_Interrupts_A(void);
EX_INTERRUPT_HANDLER(A_ISR); 


/*	placing the Interrupts in L2 Shared memory	*/
/*	please note that the following programs are running on a single core-core A */ 

section ("l2_shared") EX_INTERRUPT_HANDLER(A_ISR)
{
	if(*pFIO0_FLAG_C & 0x0020)	  //SW 5 is pressed	
	{	
		SECOND_STAGE_LOADER(0, 1);//(0-> indicates load executable, 1-> DXE number)
		SECOND_STAGE_LOADER(1, 0);//(1-> execute the DXE)
	}
	else if(*pFIO0_FLAG_C & 0x0040)	  //SW 6 is pressed
	{
		SECOND_STAGE_LOADER(0, 2);//load the 2nd DXE in the boot stream
		SECOND_STAGE_LOADER(1, 0);//execute the 2nd DXE
	}
} // end

section ("l2_shared") void loader_commands()
{
	*pFIO0_DIR = 0x0000;
	*pFIO0_INEN = 0x01E0;
	*pFIO0_MASKA_D = 0x01E0;
	Init_Interrupts_A();
	
	while(1);	
}

section ("l2_shared") void Init_Interrupts_A(void)
{
	*pSICA_IMASK1 |= SIC_MASK(15);
	register_handler(ik_ivg11, A_ISR);
}	
